import { ComputedStyleStorage } from './ComputedStyleStorage.js';
import { RevealBoundaryStore } from './RevealBoundryStore.js';
import type { CachedBoundingRect, CachedStyle } from './utils/types.js';
export declare class BaseConfig<T extends Element> {
    protected _store: RevealBoundaryStore;
    pxRatio: number;
    readonly container: HTMLElement;
    readonly element: T;
    protected readonly computedStyle: ComputedStyleStorage;
    paintedWidth: number;
    paintedHeight: number;
    currentFrameId: number;
    cachedBoundingRectFrameId: number;
    cachedBoundingRect: CachedBoundingRect;
    cachedStyleFrameId: number;
    cachedStyle: CachedStyle;
    dirty: boolean;
    shapeDirty: boolean;
    fillDirty: boolean;
    animationDirty: boolean;
    /**
     * If is cleaned up by `RevealBoundaryStore` during animation
     * duration checkup.
     */
    cleanedUpForAnimation: boolean;
    mouseUpClientX: number | null;
    mouseUpClientY: number | null;
    mouseDownAnimateStartFrame: number | null;
    mouseDownAnimateCurrentFrame: number | null;
    mouseDownAnimateReleasedFrame: number | null;
    mouseDownAnimateLogicFrame: number | null;
    mousePressed: boolean;
    mouseReleased: boolean;
    constructor(store: RevealBoundaryStore, $canvas: T, $container: HTMLElement);
    cacheBoundingRect: () => void;
    getTrueFillRadius: (trueFillRadius?: [number, number], fillMode?: string) => [number, number];
    getPropFromMultipleSource: (domPropsName: string, cssPropsName: string) => string;
    getNumberPropFromMultipleSource: (domPropsName: string, cssPropsName: string) => number;
    cacheCanvasPaintingStyle: () => void;
    mouseInCanvas: () => boolean;
    syncSizeToRevealRadius: (x: HTMLCanvasElement, factor: number) => void;
}
//# sourceMappingURL=BaseConfig.d.ts.map