import { RevealStateManager } from './RevealStateManager.js';
import { RevealBoundaryStore } from './RevealBoundryStore.js';
declare const PatchedHTMLElement: {
    new (): HTMLElement;
    prototype: HTMLElement;
};
export declare class AxRevealProvider extends PatchedHTMLElement {
    static readonly ElementName = "ax-reveal-provider";
    readonly stateManager: RevealStateManager;
}
export declare class AxRevealBoundary extends PatchedHTMLElement {
    static readonly ElementName = "ax-reveal-bound";
    static readonly removeStorageEvent = "removeStorage";
    static readonly attachStorageEvent = "attachStorage";
    static readonly replaceStorageEvent = "replaceStorage";
    private root;
    static readonly stateManager: RevealStateManager;
    private _storage;
    private get storage();
    private set storage(value);
    waitForStorage(f: (storage: RevealBoundaryStore) => void): void;
    private appendStorage;
    /**
     * Update the position of your pointer.
     * @param ev Pointer event from the listener.
     */
    updatePointerPosition: (ev: PointerEvent) => void;
    handlePointerEnter: () => void;
    handlePointerLeave: () => void;
    handlePointerMove: (ev: PointerEvent) => void;
    handlePointerUp: (ev: PointerEvent) => void;
    handlePointerDown: (ev: PointerEvent) => void;
    connectedCallback(): void;
    disconnectedCallback(): void;
    constructor();
}
export declare class AxReveal extends PatchedHTMLElement {
    static readonly ElementName = "ax-reveal";
    private root;
    private canvas;
    private boundary;
    adoptedCallback(): void;
    handlePointerDown: (ev: PointerEvent) => void;
    disconnectedCallback(): void;
    connectedCallback(): void;
    constructor();
}
export declare class AxRevealNg extends PatchedHTMLElement {
    static readonly ElementName = "ax-reveal-ng";
    private root;
    private svg;
    private boundary;
    adoptedCallback(): void;
    handlePointerDown: (ev: PointerEvent) => void;
    disconnectedCallback(): void;
    connectedCallback(): void;
    constructor();
}
export {};
//# sourceMappingURL=CustomElements.d.ts.map