let borderDetectionMode = 'strictEdge';
let borderDetectionModeInitialized = false;
class InitializedError extends Error {
    constructor() {
        super('Border detection mode has already been initialized.');
        this.name = 'InitializedError';
    }
}
export const config = {
    compat: false,
    get borderDetectionMode() {
        return borderDetectionMode;
    },
    set borderDetectionMode(x) {
        if (borderDetectionModeInitialized) {
            throw new InitializedError;
        }
        borderDetectionMode = x;
        borderDetectionModeInitialized = true;
    }
};
//# sourceMappingURL=config.js.map